import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import java.lang.String;

public class WeibullDst extends Frame
{  public double Pi=3.1415926535897932385;
   public double StoreRandom; public boolean evenFlag;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public WeibullDst()
   {  setSize(1100,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double Weibull(double M)
   {   double R = Math.random(); double W = 0;
       if( R != 0)
       {  R = -Math.log(R); if( R != 0) W= Math.exp(Math.log(R) / M);}
       return W;
   }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawString(Graphics g,String S, double X, double Y)
   {  g.drawString(S, Xpos(X)-2,Ypos(Y)-2);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   private void LineDsp(Graphics g,double X0, double Y0, double SX, double SY,
                         int N, double MY, double Mstep, double Xst, double Xed, double Xstep)
   {
     drawInit(X0, Y0, SX,SY);  g.setColor(new Color(128,128,128));
     for(double XX=Xst;XX<=Xed; XX += Xstep) drawLine(g,XX,0, XX,MY);
     for(double Y=0;Y<= (MY+Mstep/2); Y +=Mstep) drawLine(g,Xst,Y,Xed,Y);
     g.setColor(new Color(255,0,0));
   }
   private void ResultDsp(Graphics g,double[][] X, int N, int Ist, Color C)
   {
     g.setColor(C);
     boolean Flag=false;
     for(int i = Ist;i<N; i++)
     { Flag = Draw(g,X[0][i],X[1][i], Flag);
     }
     g.setColor(new Color(0,0,255));
  
   }
   public double[][] DistributionW(double A)
   { evenFlag=true;int M=100;int NS=12; int M2 = M * NS;
     double X[][] = new double[2][M2]; int N = 1000000;
     int i, j, k;
     for(i = 0; i < M2 ; i++) X[1][i] = 0;
     for(k = 1; k <= N   ; k++)
     {  j = (int)( Weibull(A)*M);
        if( j >= 0 && j < M2) X[1][j] ++;
     }
     for(i = 0; i < M2 ; i++)
     {   X[0][i]  = (double)i / M ;
         X[1][i] /= N;
     }
     return X;
   }

   public void paint(Graphics g)
   { setTitle("Cuz̗");double[][] X ;
     LineDsp(g, 200, 450, 40, -10000, 1200, 0.020, 0.001, 0, 12,0.5);
     X = DistributionW(2.0); ResultDsp(g, X, 1200,0, new Color(255,  0,  0));
     X = DistributionW(0.5); ResultDsp(g, X, 1200,4, new Color(  0,160,  0));
     X = DistributionW(1.0); ResultDsp(g, X, 1200,0, new Color(  0,  0,255));
   } 
   public static void main(String[] args)
   {  Frame w = new WeibullDst();
      w.setVisible(true);
   }
}
